#! /bin/bash
# sudo로 실행 필요

# K8s 설치
# 네트워크 설정
echo -e "br_netfilter" >> /etc/modules-load.d/k8s.conf
echo -e "net.bridge.bridge-nf-call-ip6tables = 1\nnet.bridge.bridge-nf-call-iptables = 1" >> /etc/sysctl.d/k8s.conf
sysctl --system

# K8s 설치
apt-get update
apt-get install -y apt-transport-https ca-certificates curl
rm -f /usr/share/keyrings/kubernetes-archive-keyring.gpg
curl -fsSLo /usr/share/keyrings/kubernetes-archive-keyring.gpg https://packages.cloud.google.com/apt/doc/apt-key.gpg
echo "deb [signed-by=/usr/share/keyrings/kubernetes-archive-keyring.gpg] https://apt.kubernetes.io/ kubernetes-xenial main" | sudo tee /etc/apt/sources.list.d/kubernetes.list
apt-get update
apt-get install -y kubelet kubeadm kubectl
apt-mark hold kubelet kubeadm kubectl
rm /etc/containerd/config.toml
systemctl restart containerd.service
echo 'source <(kubectl completion bash)' >> /root/.bashrc
kubectl completion bash >/etc/bash_completion.d/kubectl

MASTER_IP=`hostname -I | awk '{print $1}'`
kubeadm init --apiserver-advertise-address="${MASTER_IP}" --pod-network-cidr "10.244.0.0/16" --control-plane-endpoint="${MASTER_IP}"
export ROOT=/root
export HOME=/home/vraptor
mkdir -p $ROOT/.kube
mkdir -p $HOME/.kube
cp /etc/kubernetes/admin.conf $ROOT/.kube/config
cp /etc/kubernetes/admin.conf $HOME/.kube/config
chown root:root $ROOT/.kube/config
chown -R  vraptor:vraptor $HOME/.kube
